<!DOCTYPE html>
<html>
  <head>
    <title>IoT 101 - WiFi</title>
    <meta charset="utf-8">

    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/reveal.js/3.6.0/css/reveal.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/reveal.js/3.6.0/css/theme/white.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/styles/arduino-light.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.8.2/css/all.min.css">

    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/clipboard.js/2.0.4/clipboard.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/reveal.js/3.6.0/lib/js/head.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/reveal.js/3.6.0/js/reveal.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/highlight.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/arduino.min.js"></script>

    <style>
      @import url(https://fonts.googleapis.com/css?family=Open+Sans+Condensed:300,700);
      @import url(https://fonts.googleapis.com/css?family=Open+Sans:400,700,400italic);
      @import url(https://fonts.googleapis.com/css?family=Ubuntu+Mono:400,700,400italic);

      body { font-family: 'Open Sans'; }

      .reveal { font-size: 28px; }
      .reveal .slides section { text-align: left; }
      .reveal .slides section.title { padding-top: 20%; text-align: center; }

      .reveal .slides::before {
        background-image: url(https://ballarathackerspace.org.au/images/bhack-logo-title-black.svg);
        background-repeat: no-repeat;
        background-size: contain;
        bottom: 8px;
        content: '';
        height: 32px;
        left: 8px;
        position: absolute;
        width: 128px;
      }

      .reveal h1, .reveal h2, .reveal h3 { font-family: 'Open Sans Condensed'; font-weight: 700; }

      .reveal pre {
        border: 1px solid #ccc;
        box-shadow: 0px 0px 6px rgba(0, 0, 0, 0.1);
        margin: 20px 0;
        padding: 4px 0;
        width: 100%;
      }

      .reveal code { font-family: 'Ubuntu Mono'; }

      .reveal pre code { margin: 2px; }
      .feature-image,
      .full-image { text-align: center; }

      .feature-image img { max-height: 256px; }

      .full-image img { max-height: 512px; padding-top: 48px; }

      .sponsors { margin-top: 96px!important; text-align: center; }
      .sponsors img { max-height: 64px; }
      .sponsors img+img { margin-left: 16px; }

      .reveal ol, .reveal dl, .reveal ul { margin: 0 0 0 2em; }
      .reveal p, .reveal li { text-align: justify; }
      .reveal section img { border: none; box-shadow: none; }

      .btn {
        background-color: transparent;
        border: 1px solid #f0f0f0;
        color: #000;
        outline: 0;
        padding: 4px 8px;
        cursor: pointer;
      }

      .btn:active {
        background-color: #ddd !important;
      }

      .btn:hover {
        background-color: #eee;
        border: 1px solid #ddd;
      }

      .btn-copy {
        position: fixed;
        right: 20px;
      }
    </style>
  </head>
  <body>
    <div class="reveal">
      <div class="slides">

    <!-- 010-title.md -->
    <section class="title">
      <h1>The Internet of Things – 101</h1>
<h3>An Arduino/ESP32 Workshop</h3>
<div class="sponsors">
  <img src="https://startupballarat.com.au/img/Startup-Ballarat-Logo.png" />
  <img src="https://ballarathackerspace.org.au/images/bhack-logo-title-black.svg" />
</div>


    </section>
    <!-- 110-administration.md -->
    <section class="title">
      <h1>Administrivia</h1>


    </section>
    <!-- 120-welcome.md -->
    <section class="title">
      <h1>Welcome</h1>


    </section>
    <!-- 130-agenda.md -->
    <section class="">
      <h2>Agenda</h2>
<ol>
<li>Introduction</li>
<li>Hardware</li>
<li>Software</li>
<li>Challenges</li>
</ol>


    </section>
    <!-- 140-introduction.md -->
    <section class="">
      <h2>Introduction</h2>
<p>This workshop will walk you through a few common IoT scenarios from basic user input through to publishing to and responding from online sources.</p>
<p>You will learn:</p>
<ul>
<li>Foundation elements of the Internet of Things.</li>
<li>Foundation elements of the MQTT protocol.</li>
<li>How to navigate and use the Arduino IDE.</li>
<li>How to connect sensors and code.</li>
<li>Measure sensor values like temperature, air quality, etc and interact with these values via a web browser.</li>
<li>Make your first little Internet of Things project!</li>
</ul>


    </section>
    <!-- 150-iot-title.md -->
    <section class="title">
      <h1>INTERNET OF THINGS</h1>
<h3>IoT</h3>


    </section>
    <!-- 155-iot-graph.md -->
    <section class="">
      <div class="full-image">
  <img src="./img/iot2.png" />
</div>


    </section>
    <!-- 156-what-is-iot.md -->
    <section class="">
      <h2>What is the Internet of Things?</h2>
<p>Network of physical devices, including but not limited to:</p>
<ul>
<li>vehicles</li>
<li>humans,</li>
<li>home appliances, and other items embedded with electronics</li>
<li>cows,</li>
<li>sensors and actuators</li>
</ul>
<p>IoT involves extending Internet connectivity beyond standard devices to any range of traditionally dumb or non-internet-enabled physical devices and everyday objects.</p>


      <aside class="notes">
        <p>The Internet of Things (IoT) is the network of physical devices, vehicles, home appliances, and other items embedded with electronics, software, sensors, actuators, and connectivity which enables these things to connect and exchange data, creating opportunities for more direct integration of the physical world into computer-based systems, resulting in efficiency improvements, economic benefits, and reduced human exertions.</p>
<p>IoT involves extending Internet connectivity beyond standard devices, such as desktops, laptops, smartphones and tablets, to any range of traditionally dumb or non-internet-enabled physical devices and everyday objects.</p>
<p>Embedded with technology, these devices can communicate and interact over the Internet, and they can be remotely monitored and controlled.</p>

      </aside>
    </section>
    <!-- 157-iot-graph.md -->
    <section class="">
      <div class="full-image">
  <img src="./img/iot-graph.png" />
</div>


    </section>
    <section>
        <!-- 160-iot-protocols.md -->
        <section class="">
          <h2>Protocols</h2>
<div class="full-image">
  <img src="./img/logo-protocols.png" />
</div>
<p>Depending on the application, factors such as range, data requirements, security and power demands and battery life will dictate the choice of one or some form of combination of technologies.</p>



        </section>
        <!-- 161-iot-protocols-bluetooth.md -->
        <section class="">
          <h2>Bluetooth</h2>
<ul>
<li>Standard: Bluetooth 4.2 core specification</li>
<li>Frequency: 2.4GHz (ISM)</li>
<li>Range: 50-150m (Smart/BLE)</li>
<li>Data Rates: 1Mbps (Smart/BLE)</li>
</ul>



        </section>
        <!-- 162-iot-protocols-zigbee.md -->
        <section class="">
          <h2>ZigBee</h2>
<ul>
<li>Standard: ZigBee 3.0 based on IEEE802.15.4</li>
<li>Frequency: 2.4GHz</li>
<li>Range: 10-100m</li>
<li>Data Rates: 250kbps</li>
</ul>



        </section>
        <!-- 163-iot-protocols-cellular.md -->
        <section class="">
          <h2>Cellular</h2>
<ul>
<li>Standard: GSM/GPRS/EDGE (2G), UMTS/HSPA (3G), LTE (4G)</li>
<li>Frequencies: 900/1800/1900/2100MHz</li>
<li>Range: 35km max for GSM; 200km max for HSPA</li>
<li>Data Rates (typical download): 35-170kps (GPRS), 120-384kbps (EDGE), 384Kbps-2Mbps (UMTS), 600kbps-10Mbps (HSPA), 3-10Mbps (LTE)</li>
</ul>



        </section>
        <!-- 163-iot-protocols-lora.md -->
        <section class="">
          <h2>Lora</h2>
<ul>
<li>Standard: LoRa</li>
<li>Frequency: Various</li>
<li>Range: 2-5km (urban environment), 15km (suburban environment)</li>
<li>Data Rates: 0.3-50 kbps</li>
</ul>



        </section>
        <!-- 163-iot-protocols-wifi.md -->
        <section class="">
          <h2>WiFi</h2>
<ul>
<li>Standard: Based on 802.11n (most common usage in homes today)</li>
<li>Frequencies: 2.4GHz and 5GHz bands</li>
<li>Range: Approximately 50m</li>
<li>Data Rates: 600 Mbps maximum, but 150-200Mbps is more typical, depending on channel frequency used and number of antennas (latest 802.11-ac standard should offer 500Mbps to 1Gbps)</li>
</ul>



        </section>
    </section>

    <section>
        <!-- 170-mqtt.md -->
        <section class="title">
          <h1>MQTT</h1>



        </section>
        <!-- 171-mqtt-architecture.md -->
        <section class="">
          <h2>Architecture Overview</h2>
<div class="full-image">
  <img src="./img/mqtt-overview.jpg" />
</div>



        </section>
        <!-- 172-mqtt-message-cycle -->
        <section class="">
          <h2>Messaging (QOS 0)</h2>
<div class="full-image">
  <img src="./img/mqtt-message-cycle-qos0.png" />
</div>



        </section>
        <!-- 175-mqtt-network-stack.md -->
        <section class="">
          <h2>Network Stack</h2>
<ul>
<li>Sits at layers 5-7 of the OSI network model</li>
</ul>
<div class="full-image">
  <img src="./img/mqtt-network-protocols.png" />
</div>



        </section>
    </section>

    <section>
        <!-- 200-arduino.md -->
        <section class="title">
          <h1>Arduino</h1>
<div class="full-image">
  <img src="./img/logo-arduino.png" />
</div>



        </section>
        <!-- 210-arduino.md -->
        <section class="">
          <h2>Arduino</h2>
<p>Arduino is an open-source platform used for building electronics projects. Arduino consists of both a physical programmable circuit board and a piece of software, or IDE that runs on your computer, used to write and upload code to the physical board.</p>
<ul>
<li>Single board microcontroller</li>
<li>8-bit Atmel AVR or 32-bit Atmel ARM</li>
<li>UNO offers 6 analog inputs pins and 14 digital I/O pins</li>
<li>Intially released in 2005&lt;</li>
</ul>
<div class="feature-image">
  <img src="https://cdn.sparkfun.com/assets/9/1/e/4/8/515b4656ce395f8a38000000.png" />
</div>



        </section>
        <!-- 220-arduino-simplicity.md -->
        <section class="">
          <h2>Arduino - Simplicity</h2></h2>
<ul>
<li>Easy - Programmed based on common language (C/C++ compatible)</li>
<li>Cheap</li>
<li>Low Energy - ~0.1W</li>
<li>Durable - fanless, little to no heat</li>
<li>Open source, open hardware</li>
</ul>
<div class="feature-image">
  <img src="https://upload.wikimedia.org/wikipedia/commons/a/a1/Arduino_IDE_-_Blink.png" />
  <img src="http://www.krystalinkz.com/wp-content/uploads/2017/01/microusb.jpg" />
</div>



        </section>
        <!-- 230-arduino-ecosystem.md -->
        <section class="">
          <h2>Arduino - Ecosystem</h2>
<p>Arduino compatible devices come in a variety of form factors from the tiny to the large.</p>
<p>Many different microcontrollers are supported by the Arduino ecosystem and thus their capabilities also vary considerably.</p>
<div class="feature-image">
  <img src="https://cdn.sparkfun.com/r/600-600/assets/7/1/9/0/c/5228fb7a757b7fb7568b456d.png" />
  <img src="https://core-electronics.com.au/media/catalog/product/cache/1/image/650x650/fe1bcd18654db18f328c2faaaf3c690a/3/4/3405-00_1.jpg" />
</div>



        </section>
        <!-- 240-adafruit-feather-huzzah32.md -->
        <section class="">
          <h2>Adafruit Feather HUZZAH32</h2>
<div class="feature-image">
  <img src="https://core-electronics.com.au/media/catalog/product/cache/1/image/650x650/fe1bcd18654db18f328c2faaaf3c690a/3/4/3405-00_1.jpg" />
</div>
<p>USB-to-Serial converter, Automatic bootloader reset, Lithium Ion/Polymer charger, and a lot of the GPIOs brought out so you can use it with any of the Feather Wings.</p>
<p>The dual core ESP32 has both WiFi and Bluetooth Classic/LE support which means it's perfect for just about any wireless or Internet-connected project.</p>



        </section>
        <!-- 245-adafruit-feather-huzzah32-specifications.md -->
        <section class="">
          <h2>ESP32 Specifications</h2>
<ul>
<li>240 MHz dual core microcontroller with 520KB SRAM</li>
<li>Integrated 802.11b/g/n WiFi, and dual mode Bluetooth (classic and BLE)</li>
<li>4 MByte flash include in the WROOM32 module</li>
<li>On-board PCB antenna</li>
<li>Ultra-low noise analog amplifier</li>
<li>Hall sensor</li>
<li>10x capacitive touch interface</li>
<li>3 x UARTs</li>
<li>3 x SPI (only one is configured by default in the Feather Arduino IDE support)</li>
<li>2 x I2C (only one is configured by default in the Feather Arduino IDE support)</li>
<li>12 x ADC input channels</li>
<li>2 x I2S Audio</li>
<li>2 x DAC</li>
<li>PWM/timer input/output available on every GPIO pin</li>
<li>and much, much more ...</li>
</ul>



        </section>
    </section>

    <section>
        <!-- 500-hardware.md -->
        <section class="title">
          <h1>Hardware Building Blocks</h1>



        </section>
        <!-- 501-hardware-inventory.md -->
        <section class="">
          <h2>Inventory</h2>
<p>Here's what you'll need in order to complete this workshop:</p>
<ul>
<li>Adafruit Feather HUZZAH32</li>
<li>Breadboard</li>
<li>M/M Jumper Wires</li>
<li>5x LEDs</li>
<li>TMP36</li>
<li>9g Servo</li>
<li>CO2 Sensor</li>
<li>3x NeoPixels</li>
<li>Rotaty Encoder with Push Button</li>
</ul>
<div class="feature-image">
  <img src="./img/all_bb.png" />
</div>



        </section>
        <!-- 521-hardware-led.md -->
        <section class="">
          <h2>LED</h2>
<ul>
<li>Emits light when current passes through</li>
<li>Polarised (current flows A to K)</li>
</ul>
<div class="full-image">
  <img src="./img/parts-led.png" />
</div>



        </section>
        <!-- 522-hardware-rotary-encoder.md -->
        <section class="">
          <h2>Rotary Encoder</h2>
<ul>
<li>Pulsed output on rotation</li>
<li>A and B phase for direction detection</li>
<li>Momentary push button</li>
</ul>
<div class="full-image">
  <img src="./img/parts-rotary-encoder.png" />
</div>



        </section>
        <!-- 523-hardware-tmp36.md -->
        <section class="">
          <h2>TMP36 - Temperature Sensor</h2>
<ul>
<li>-40 to 150C</li>
<li>Output voltage linearly proportional to temperature</li>
</ul>
<div class="full-image">
  <img src="./img/parts-tmp36.png" />
</div>



        </section>
        <!-- 524-hardware-gas-sensor.md -->
        <section class="">
          <h2>Gas Sensor</h2>
<ul>
<li>Measures wide range of Volatile Organic Compounds (VOCs)</li>
<li>I2C Interface</li>
</ul>
<div class="full-image">
  <img src="./img/parts-gas-sensor.png" />
</div>



        </section>
        <!-- 525-hardware-9g-servo.md -->
        <section class="">
          <h2>9g Servo</h2>
<ul>
<li>Precision controlled angle between 0 and 180 degrees</li>
<li>PWM input</li>
</ul>
<div class="full-image">
  <img src="./img/parts-9g-servo.png" />
</div>



        </section>
        <!-- 526-hardware-neopixel.md -->
        <section class="">
          <h2>Neopixel</h2>
<ul>
<li>RGB output</li>
<li>Custom input protocol with strict timing requiremeints</li>
</ul>
<div class="full-image">
  <img src="./img/parts-neopixel.png" />
</div>



        </section>
        <!-- 527-hardware-huzzah32.md -->
        <section class="">
          <h2>Huzzah32</h2>
<div class="full-image">
  <img src="./img/parts-huzzah32-feather-pinout.png" />
</div>



        </section>
    </section>

    <!-- 600-prototyping.md -->
    <section class="title">
      <h1>Let's Get Prototyping ...</h1>


    </section>
    <section>
        <!-- 610-blinking-led-wave.md -->
        <section class="title">
          <h1>Project #1</h1>
<h2>Creating a blinking LED wave</h2>
<div class="full-image">
  <img src="./img/bulb.png" />
</div>



        </section>
        <!-- 611-blw-algorithm.md -->
        <section class="">
          <h2>The Algorithm</h2></h2>
<p>Here's our algorithm for the project:</p>
<ul>
<li>Turn on LED 1.</li>
<li>Wait half a second.</li>
<li>Turn off LED 1.</li>
<li>Turn on LED 2.</li>
<li>Wait half a second.</li>
<li>Turn off LED 2.</li>
<li>Continue until LED 5 is turned on, at which point the process reverses from LED 5 to 1.</li>
<li>Repeat indefinitely.</li>
</ul>



        </section>
        <!-- 612-blw-hardware.md -->
        <section class="">
          <h2>The Hardware</h2>
<p>Here's what you'll need to create this project:</p>
<ul>
<li>Five LEDs</li>
<li>One breadboard</li>
<li>Various connecting wires</li>
<li>HUZZAH32 and USB cable</li>
</ul>
<p>We will connect the LEDs to digital pins 27, 33, 15, 32 and 14.</p>



        </section>
        <!-- 613-blw-layout.md -->
        <section class="">
          <h2>The Layout</h2>
<div class="feature-image">
  <img src="./img/basic-led-wave_bb.png" />
</div>



        </section>
        <!-- 614-sketch.md -->
        <section class="">
          <h2>The Sketch</h2>
<p>Now for our sketch. Here is a worked example you can enter straight into the IDE:</p>
<pre><code class="language-arduino">// Project 1 - Creating a Blinking LED Wave
void setup() {
  Serial.begin(115200);

  pinMode(27, OUTPUT); // LED 1 control pin is set up as an output
  pinMode(33, OUTPUT); // same for LED 2 to LED 5
  pinMode(15, OUTPUT);
  pinMode(32, OUTPUT);
  pinMode(14, OUTPUT);

  Serial.println(&quot;setup() complete.&quot;);
}

void loop() {
  digitalWrite(27, HIGH); // turn LED 1 on
  delay(500);             // wait half a second
  digitalWrite(27, LOW);  // turn LED 1 off
  digitalWrite(33, HIGH); // and repeat for LED 2 to 5
  delay(500);
  digitalWrite(33, LOW);
  digitalWrite(15, HIGH);
  delay(500);
  digitalWrite(15, LOW);
  digitalWrite(32, HIGH);
  delay(500);
  digitalWrite(32, LOW);
  digitalWrite(14, HIGH);
  delay(500);
  digitalWrite(14, LOW);
  digitalWrite(32, HIGH);
  delay(500);
  digitalWrite(32, LOW);
  digitalWrite(15, HIGH);
  delay(500);
  digitalWrite(15, LOW);
  digitalWrite(33, HIGH);
  delay(500);
  digitalWrite(33, LOW);
  // the loop() will now loop around and start from the top again
}
</code></pre>



        </section>
        <!-- 615-sketch-refactor.md -->
        <section class="">
          <h2>The Sketch - Refactor 2</h2>
<p>We can use an array to organise our pin assignments in programmatical way.</p>
<pre><code class="language-arduino">// Project 1 - Creating a Blinking LED Wave
#define LED1 27
#define LED2 33
#define LED3 15
#define LED4 32
#define LED5 14

int leds[5] = {LED1, LED2, LED3, LED4, LED5};

void setup() {
  Serial.begin(115200);

  pinMode(LED1, OUTPUT); // LED 1 control pin is set up as an output
  pinMode(LED2, OUTPUT); // same for LED 2 to LED 5
  pinMode(LED3, OUTPUT);
  pinMode(LED4, OUTPUT);
  pinMode(LED5, OUTPUT);

  Serial.println(&quot;setup() complete.&quot;);
}

void loop() {
  for (int f=0; f&lt;5; f++) {
    digitalWrite(leds[f], HIGH); // Turn LED on
    delay(500);                  // wait half a second
    digitalWrite(leds[f], LOW);  // Turn LED off
  }

  for (int r=4; r&gt;=1; r--) {
    digitalWrite(leds[r], HIGH); // Turn LED on
    delay(500);                  // wait half a second
    digitalWrite(leds[r], LOW);  // Turn LED off
  }

 // the loop() will now loop around and start from the top again
}
</code></pre>



        </section>
        <!-- 616-challenges.md -->
        <section class="">
          <h2>Challenges</h2>
<p>Try and complete the following:</p>
<ol>
<li>Increase the speed of scanning.</li>
<li>Start the scan from the centre LED, then out to the edge LEDs and back to the center LED.</li>
</ol>



        </section>
    </section>

    <section>
        <!-- 620-subscribing-to-the-cloud.md -->
        <section class="title">
          <h1>Project #2</h1>
<h2>Subscribing to the cloud</h2>
<div class="full-image">
  <img src="./img/cloud-subscribe.png" />
</div>



        </section>
        <!-- 621-sttc-algorithm.md -->
        <section class="">
          <h2>The Algorithm</h2>
<p>Here's our algorithm for the project:</p>
<ul>
<li>Connect to a WiFi network.</li>
<li>Connect to the public Ballarat Hackerspace Streams (MQTT) service.</li>
<li>Subscribe to a data topic.</li>
<li>Turn on an LED when we receive data.</li>
<li>Wait half a second.</li>
<li>Turn off LED.</li>
<li>Repeat indefinitely.</li>
</ul>



        </section>
        <!-- 622-sttc-hardware.md -->
        <section class="">
          <h2>The Hardware</h2>
<p>Here's what you'll need to create this project:</p>
<ul>
<li>One LED</li>
<li>One breadboard</li>
<li>Various connecting wires</li>
<li>HUZZAH32 and USB cable</li>
</ul>
<p>We will connect the LED to digital pins 27.</p>



        </section>
        <!-- 623-sttc-layout.md -->
        <section class="">
          <h2>The Layout</h2>
<div class="feature-image">
  <img src="./img/basic-led-subscribe_bb.png" />
</div>



        </section>
        <!-- 624-sttc-sketch.md -->
        <section class="">
          <h2>The Sketch</h2>
<p>Now for our sketch. Here is a worked example you can enter straight into the IDE:</p>
<pre><code class="language-arduino">// Project 2 - Subscribing to the cloud
#include &quot;BHStreams.h&quot;

#define LED 27

const char* ssid = &quot;INSERT SSID&quot;;
const char* password = &quot;INSERT PASSWORD&quot;;

BHStreams bhs;

void flash() {
  digitalWrite(LED, HIGH);
  delay(250);
  digitalWrite(LED, LOW);
  delay(250);
}

void onData(BHStreams_Data *data) {
  flash();

  Serial.printf(&quot;got message: %s\n&quot;, data-&gt;toChar());
}

void setup() {
  Serial.begin(115200);

  pinMode(LED, OUTPUT);

  bhs.begin(ssid, password);
  bhs.connect();
  bhs.onFeed(&quot;iot-control&quot;, onData);

  flash();
  flash();

  Serial.println(&quot;setup() complete.&quot;);
}

void loop() {
  bhs.process(); // manage WiFi connection, and any MQTT or OTA messages
}
</code></pre>



        </section>
        <!-- 629-sttc-challenges.md -->
        <section class="">
          <h2>Challenges</h2>
<p>Try and complete the following:</p>
<ol>
<li>Subscribe to other feeds.</li>
<li>Uniquely flash the LED for different feeds.</li>
</ol>



        </section>
    </section>

    <section>
        <!-- 630-publish-to-the-cloud.md -->
        <section class="title">
          <h1>Project #3</h1>
<h2>Publishing to the cloud</h2>
<div class="full-image">
  <img src="./img/cloud-publish.png" />
</div>



        </section>
        <!-- 631-pttc-algorithm.md -->
        <section class="">
          <h2>The Algorithm</h2>
<p>Here's our algorithm for the project:</p>
<ul>
<li>Connect to a WiFi network.</li>
<li>Connect to the public Ballarat Hackerspace Streams (MQTT) service.</li>
<li>Subscribe to a data topic.</li>
<li>Turn on an LED when we receive data, wait half a second and turn off.</li>
<li>Check if button is pushed and publish a unique ID to a data topic.</li>
<li>Repeat indefinitely.</li>
</ul>



        </section>
        <!-- 632-pttc-hardware.md -->
        <section class="">
          <h2>The Hardware</h2>
<p>Here's what you'll need to create this project:</p>
<ul>
<li>One LED</li>
<li>One push button</li>
<li>One breadboard</li>
<li>Various connecting wires</li>
<li>HUZZAH32 and USB cable</li>
</ul>



        </section>
        <!-- 633-pttc-layout.md -->
        <section class="">
          <h2>The Layout</h2>
<div class="feature-image">
  <img src="./img/basic-led-button-publish_bb.png" />
</div>



        </section>
        <!-- 634-sketch.md -->
        <section class="">
          <h2>The Sketch</h2>
<p>Now for our sketch. Here is a worked example you can enter straight into the IDE:</p>
<pre><code class="language-arduino">// Project 3 - Publishing to the cloud
#include &quot;BHStreams.h&quot;

#define LED 27
#define BUTTON 33

const char* ssid = &quot;INSERT SSID&quot;;
const char* password = &quot;INSERT PASSWORD&quot;;

BHStreams bhs;
uint32_t lastButton = 0;

void flash() {
  digitalWrite(LED, HIGH);
  delay(250);
  digitalWrite(LED, LOW);
  delay(250);
}

void onData(BHStreams_Data *data) {
  flash();

  Serial.printf(&quot;got message: %s\n&quot;, data-&gt;toChar());
}

void setup() {
  Serial.begin(115200);

  pinMode(LED, OUTPUT);
  pinMode(BUTTON, INPUT_PULLUP);

  bhs.begin(ssid, password);
  bhs.connect();
  bhs.onFeed(&quot;iot-control&quot;, onData);

  flash();
  flash();

  Serial.println(&quot;setup() complete.&quot;);
}

void loop() {
  bhs.process(); // manage WiFi connection, and any MQTT or OTA messages

  uint32_t now = millis();

  if (!digitalRead(BUTTON) &amp;&amp; (now - lastButton &gt; 1000)) {
    bhs.write(&quot;iot-announce&quot;, &quot;My Feather&quot;);
    Serial.println(&quot;data sent.&quot;);
    lastButton = now;
  }
}
</code></pre>



        </section>
        <!-- 639-challenges.md -->
        <section class="">
          <h2>Challenges</h2>
<p>Try and complete the following:</p>
<ol>
<li>Publish to your own channel.</li>
<li>Publish unique data based on the duration/frequency of button presses.</li>
</ol>



        </section>
    </section>

    <section>
        <!-- 640-make-it-rain.md -->
        <section class="title">
          <h1>Project #4</h1>
<h2>Making It Rain - All the Data</h2>
<div class="full-image">
  <img src="./img/cloud-rain.png" />
</div>



        </section>
        <!-- 643-mir-layout.md -->
        <section class="">
          <h2>The Layout</h2>
<div class="feature-image">
  <img src="./img/basic-led-button-temp-gas-publish_bb.png" />
</div>



        </section>
        <!-- 644-mir-sketch.md -->
        <section class="">
          <h2>The Sketch</h2>
<p>Now for our sketch. Here is a worked example you can enter straight into the IDE:</p>
<pre><code class="language-arduino">// Project 4 - Making it rain
#include &quot;Adafruit_CCS811.h&quot;
#include &quot;BHStreams.h&quot;

#define LED 27
#define TEMPERATURE 26 // A0=26, A1=25, A2=34
#define BUTTON 33

const char* ssid = &quot;INSERT SSID&quot;;
const char* password = &quot;INSERT PASSWORD&quot;;


Adafruit_CCS811 ccs;
BHStreams bhs;
uint32_t lastButton = 0;
uint32_t lastGas = 0;
uint32_t lastTemp = 0;

void flash() {
  digitalWrite(LED, HIGH);
  delay(250);
  digitalWrite(LED, LOW);
  delay(250);
}

void onData(BHStreams_Data *data) {
  flash();

  Serial.printf(&quot;got message: %s\n&quot;, data-&gt;toChar());
}

void setup() {
  Serial.begin(115200);

  pinMode(LED, OUTPUT);
  pinMode(BUTTON, INPUT_PULLUP);
  pinMode(TEMPERATURE, INPUT);

  if (!ccs.begin()){
    Serial.println(&quot;Failed to start sensor! Please check your wiring.&quot;);
    while(1);
  }

  bhs.begin(ssid, password);
  bhs.connect();
  bhs.onFeed(&quot;iot-control&quot;, onData);

  flash();
  flash();

  Serial.println(&quot;setup() complete.&quot;);
}

void loop() {
  bhs.process(); // manage WiFi connection, and any MQTT or OTA messages

  uint32_t now = millis();

  if (!digitalRead(BUTTON) &amp;&amp; (now - lastButton &gt; 1000)) {
    bhs.write(&quot;iot-announce&quot;, &quot;My Feather&quot;);
    Serial.println(&quot;data sent.&quot;);
    lastButton = now;
  }

  // read gas sensor when data is available
  if ((now - lastGas) &gt; 30000 &amp;&amp; ccs.available() &amp;&amp; !ccs.readData()) {  // readData returns true on error
    int eCO2 = ccs.geteCO2();                // collect eCO2
    int TVOC = ccs.getTVOC();                // collect TVOC
    float temp = ccs.calculateTemperature(); // approximate ambient temperature

    bhs.write(&quot;iot/eCO2/value&quot;, eCO2);
    bhs.write(&quot;iot/TVOC/value&quot;, TVOC);

    lastGas = now;
  }

  // converting that reading to voltage, for 3.3v arduino use 3.3
  if ((now - lastTemp) &gt; 30000) {
    float voltage = analogRead(TEMPERATURE) * 3.3 / 4096.0;
    float temperatureC = (voltage - 0.5) * 100 ;  //converting from 10 mv per degree wit 500 mV offset to degrees ((voltage - 500mV) times 100)
    Serial.printf(&quot;%f degrees C\n&quot;, temperatureC);

    bhs.write(&quot;iot/temperature/value&quot;, temperatureC);

    lastTemp = now;
  }
}
</code></pre>



        </section>
        <!-- 649-mir-challenges.md -->
        <section class="">
          <h2>Challenges</h2>
<p>Try and complete the following:</p>
<ol>
<li>Use servo as a guage for external data</li>
<li>Use the Neopixels to visually represent the temperature in Paris</li>
</ol>



        </section>
    </section>

    <section>
        <!-- 650-guages-and-visuals.md -->
        <section class="title">
          <h1>Project #5</h1>
<h2>Gauge and Visuals</h2>
<div class="full-image">
  <img src="./img/gauge-visuals.png" />
</div>



        </section>
        <!-- 653-gav-layout.md -->
        <section class="">
          <h2>The Layout</h2>
<div class="feature-image">
  <img src="./img/basic-button-servo-pixel_bb.png" />
</div>



        </section>
        <!-- 654-gav-sketch.md -->
        <section class="">
          <h2>The Sketch</h2>
<p>Now for our sketch. Here is a worked example you can enter straight into the IDE:</p>
<pre><code class="language-arduino">// Project 5 - Gauges and Visuals
#include &lt;Adafruit_NeoPixel.h&gt;
#include &lt;ESP32Servo.h&gt;
#include &quot;BHStreams.h&quot;

#define ANGLE_STEP_SIZE 1

#define BUTTON 15
#define NEOPIXELS 33
#define SERVO 14

const char* ssid = &quot;INSERT SSID&quot;;
const char* password = &quot;INSERT PASSWORD&quot;;

Adafruit_NeoPixel strip = Adafruit_NeoPixel(2, NEOPIXELS, NEO_GRB + NEO_KHZ800);
BHStreams bhs;
Servo servo;

int angle = 0;                   // servo position in degrees
int angleDir = ANGLE_STEP_SIZE;  // servo angle direction and magnitude

uint32_t lastButton = 0;
uint32_t lastUpdate = 0;

void flash() {
  strip.setPixelColor(0, 255, 0, 0); // red
  strip.setPixelColor(1, 0, 255, 0); // green
  strip.show();
  delay(250);
  strip.setPixelColor(0, 0, 0, 0); // off
  strip.setPixelColor(1, 0, 0, 0); // off
  delay(250);
  strip.show();
}

void onData(BHStreams_Data *data) {
  flash();

  int newAngle = constrain(data-&gt;toUnsignedInt(), 0, 180);

  Serial.printf(&quot;got message: %d\n&quot;, newAngle);

  if (angle - newAngle &gt; 0) {
    angleDir = ANGLE_STEP_SIZE;
  } else {
    angleDir = -ANGLE_STEP_SIZE;
  }

  angle = newAngle;
  servo.write(angle);
}

void setup() {
  Serial.begin(115200);

  pinMode(BUTTON, INPUT_PULLUP);
  pinMode(NEOPIXELS, OUTPUT);
  pinMode(SERVO, OUTPUT);

  strip.begin();
  flash();

  servo.attach(SERVO);

  bhs.begin(ssid, password);
  bhs.connect();
  bhs.onFeed(&quot;iot-control/servo&quot;, onData);

  flash();
  flash();

  Serial.println(&quot;setup() complete.&quot;);
}

void loop() {
  bhs.process(); // manage WiFi connection, and any MQTT or OTA messages

  uint32_t now = millis();

  if (!digitalRead(BUTTON) &amp;&amp; (now - lastButton &gt; 1000)) {
    bhs.write(&quot;iot-announce&quot;, &quot;My Feather&quot;);
    Serial.println(&quot;data sent.&quot;);
    lastButton = now;
  }

  // every 0.5 seconds, continue to sweep and fade colours
  if ((now - lastUpdate) &gt; 500) {
    if ((angle + angleDir) &lt; 0 || (angle + angleDir) &gt; 180) {
      angleDir = -angleDir;
    }

    angle += angleDir;
    servo.write(angle);

    lastUpdate = now;
  }
}
</code></pre>



        </section>
        <!-- 659-gav-challenges.md -->
        <section class="">
          <h2>Challenges</h2>
<p>Try and complete the following:</p>
<ol>
<li>Use servo as a guage for external data</li>
<li>Use the Neopixels to visually represent the temperature in Paris</li>
</ol>



        </section>
    </section>

    <section>
        <!-- 660-tft-joy-wing.md -->
        <section class="title">
          <h1>Project #6</h1>
<h2>TFT and Joystick Wing</h2>
<div class="full-image">
  <img src="./img/tft-joy-wing.png" />
</div>



        </section>
        <!-- 663-tjw-layout.md -->
        <section class="">
          <h2>The Layout</h2>
<div class="feature-image">
  <img src="./img/basic-servo-pixel_bb.png" />
</div>



        </section>
        <!-- 664-tjw-sketch.md -->
        <section class="">
          <h2>The Sketch</h2>
<p>Now for our sketch. Here is a worked example you can enter straight into the IDE:</p>
<pre><code class="language-arduino">#include &lt;Adafruit_GFX.h&gt;
#include &lt;Adafruit_ST7735.h&gt;
#include &lt;Adafruit_miniTFTWing.h&gt;
#include &lt;ESP32Servo.h&gt;
#include &quot;BHStreams.h&quot;

#define ANGLE_STEP_SIZE 1

#define TFT_RST  -1    // we use the seesaw for resetting to save a pin
#define TFT_CS   14
#define TFT_DC   32
#define SERVO    15

const char* ssid = &quot;INSERT SSID&quot;;
const char* password = &quot;INSERT PASSWORD&quot;;

Adafruit_miniTFTWing ss;
Adafruit_ST7735 tft = Adafruit_ST7735(TFT_CS, TFT_DC, TFT_RST);
BHStreams bhs;
Servo servo;

int angle = 0;                   // servo position in degrees
int angleDir = ANGLE_STEP_SIZE;  // servo angle direction and magnitude
uint32_t lastUpdate = 0;

void onData(BHStreams_Data *data) {
  Serial.printf(&quot;got message: %s\n&quot;, data-&gt;toChar());
}

void onServoData(BHStreams_Data *data) {
  int newAngle = constrain(data-&gt;toUnsignedInt(), 0, 180);

  Serial.printf(&quot;got angle: %d\n&quot;, newAngle);

  if (angle - newAngle &gt; 0) {
    angleDir = ANGLE_STEP_SIZE;
  } else {
    angleDir = -ANGLE_STEP_SIZE;
  }

  angle = newAngle;
  servo.write(angle);
}

void setup()   {
  Serial.begin(115200);

  pinMode(SERVO, OUTPUT);
  servo.attach(SERVO);

  if (!ss.begin()) {
    Serial.println(&quot;Seesaw couldn't be found!&quot;);
    while(1);
  }

  Serial.print(&quot;Seesaw started! Version: &quot;);
  Serial.println(ss.getVersion(), HEX);

  bhs.begin(ssid, password);
  bhs.connect();
  bhs.onFeed(&quot;iot-control&quot;, onData);
  bhs.onFeed(&quot;iot-control/servo&quot;, onServoData);

  ss.tftReset();                         // reset the display
  ss.setBacklight(TFTWING_BACKLIGHT_ON); // turn off the backlight

  tft.initR(INITR_MINI160x80);           // initialize a ST7735S chip, mini display
  Serial.println(&quot;TFT initialized&quot;);

  tft.setRotation(1);

  tft.fillScreen(ST77XX_RED);
  delay(100);
  tft.fillScreen(ST77XX_GREEN);
  delay(100);
  tft.fillScreen(ST77XX_BLUE);
  delay(100);
  tft.fillScreen(ST77XX_BLACK);

  Serial.println(&quot;setup() complete.&quot;);
}

void loop() {
  bhs.process(); // manage WiFi connection, and any MQTT or OTA messages

  uint32_t now = millis();
  uint32_t buttons = ss.readButtons();
  uint16_t color = ST77XX_BLACK;

  if (!(buttons &amp; TFTWING_BUTTON_LEFT)) {
    Serial.println(&quot;LEFT&quot;);
    color = ST77XX_WHITE;
  }
  tft.fillTriangle(150, 30, 150, 50, 160, 40, color);

  color = ST77XX_BLACK;
  if (!(buttons &amp; TFTWING_BUTTON_RIGHT)) {
    Serial.println(&quot;RIGHT&quot;);
    color = ST77XX_WHITE;
  }
  tft.fillTriangle(120, 30, 120, 50, 110, 40, color);

  color = ST77XX_BLACK;
  if (!(buttons &amp; TFTWING_BUTTON_DOWN)) {
    Serial.println(&quot;DOWN&quot;);
    color = ST77XX_WHITE;
  }
  tft.fillTriangle(125, 26, 145, 26, 135, 16, color);

  color = ST77XX_BLACK;
  if (!(buttons &amp; TFTWING_BUTTON_UP)) {
    Serial.println(&quot;UP&quot;);
    color = ST77XX_WHITE;
  }
  tft.fillTriangle(125, 53, 145, 53, 135, 63, color);

  color = ST77XX_BLACK;
  if (!(buttons &amp; TFTWING_BUTTON_A)) {
    Serial.println(&quot;A&quot;);
    color = ST7735_GREEN;
  }
  tft.fillCircle(30, 57, 10, color);

  color = ST77XX_BLACK;
  if (!(buttons &amp; TFTWING_BUTTON_B)) {
    Serial.println(&quot;B&quot;);
    color = ST77XX_YELLOW;
  }
  tft.fillCircle(30, 18, 10, color);

  color = ST77XX_BLACK;
  if (!(buttons &amp; TFTWING_BUTTON_SELECT)) {
    Serial.println(&quot;SELECT&quot;);
    color = ST77XX_WHITE;
  }
  tft.fillCircle(80, 40, 7, color);

  // every 0.5 seconds, continue to sweep back and forth
  if ((now - lastUpdate) &gt; 500) {
    if ((angle + angleDir) &lt; 0 || (angle + angleDir) &gt; 180) {
      angleDir = -angleDir;
    }

    angle += angleDir;
    servo.write(angle);

    lastUpdate = now;
  }
}
</code></pre>



        </section>
        <!-- 669-challenges.md -->
        <section class="">
          <h2>Challenges</h2>
<p>Try and complete the following:</p>
<ol>
<li>Display the last topic value on the LCD</li>
<li>Use the Servo to visually represent when the Hackerspace door is open</li>
</ol>



        </section>
    </section>

    <section>
        <!-- 900-where-to-next.md -->
        <section class="title">
          <h1>Where to next?</h1>



        </section>
        <!-- 910-resources.md -->
        <section class="">
          <h2>Resources</h2>
<p>The Ballarat Hackerspace</p>
<ul>
<li>Open Mondays, Tuesdays and Saturdays.</li>
<li>See <a href="ballarathackerspace.org.au">website</a> for details.</li>
</ul>



        </section>
        <!-- 999-wrapup.md -->
        <section class="">
          <h2>Feedback</h2>
<p><a href="https://forms.office.com/Pages/ResponsePage.aspx?id=giRth2ciDk6mT-AhAw1wkKdRFanbYSRJkA66phDD-4hURjRFRTZCQlFRTTBEMFlGM0I5SUZHMlhBOC4u">Feedback Survey</a></p>



        </section>
    </section>


      </div>
    </div>
    <script>
      Reveal.initialize({
        center: false,
        fragments: true,
        fragmentInURL: true,
        history: true,
        transition: 'concave',
      });

      hljs.initHighlightingOnLoad();


      $(document).ready(function() {
        console.log('woot');
        $('pre > code').each(function() {
          var e = $(this);
          e.prepend('<button class="btn btn-copy"><i class="fas fa-copy"></i></button>');
        });

        var clipboard = new ClipboardJS('.btn-copy', {
          text: function(trigger) {
            return $(trigger).parent().text();
          }
        });
        clipboard.on('success', function(e) {
          console.log(e.text);
        });
      });


    </script>
  </body>
</html>
